Doomsday Engine - Bug #2034

[HeXen DK] Snowberry versus Ring Zero launching
2015-05-03 22:31 - vermil

Status: Closed Start date: 2015-05-03
Priority: High % Done: 100%
Assignee: Deng Team

Category: Defect

Target version: 1.15

Description

If one launches HeXen DK via Ring Zero, no map author is displayed with the map titles (correct behaviour).

But if one launches HeXen DK via Snowberry (i.e launches straight into the game basically), a map author is displayed; the default
'unknown' (incorrect behaviour)

Associated revisions

Revision f9a121a8 - 2015-05-14 23:14 - skyjake

Snowberry: Use "-iwad" when addon is an IWAD file

Needs testing with the next build to see if this is a sufficient fix.
IssuelD #2034

Revision 2bce8025 - 2015-05-15 13:54 - skyjake

Snowberry|Fixed: Always load Deathkings WAD with the "-iwad" option
IssuelD #2034

Revision 0a003e0f - 2015-05-15 21:47 - skyjake

Snowberry: All WAD addons except hexdd.wad are loaded with "-file"
IssuelD #2034

Revision 906e8e3a - 2015-05-15 21:47 - skyjake

Snowberry: All WAD addons except hexdd.wad are loaded with "-file"

IssuelD #2034

History

#1 - 2015-05-04 06:23 - danij

- Category set to Defect

- Status changed from New to In Progress
- Assignee set to danij

- Priority changed from Normal to High

- Target version setto 1.15

#2 - 2015-05-14 01:39 - danij

It appears this problem is quite simply that HEXDD.wad is being loaded twice when launched from Snowberry. A summary of what is happening in my
case at least:

Selecting game 'hexen-dk'...

Loading game resources...

Loading "$HOMEPATH%\Documents\DOOM\IWADS\HEXEN.wad". ..

IWAD identification: 0x166c805

Loading "$HOMEPATHS%\Documents\DOOM\IWADS\HEXDD.wad"...

IWAD identification: 0x480bcO

Loading " (basedir)\data\jhexen\libhexen.pk3"...

Loading "$HOMEPATHS%\Documents\Doomsday Frontend\addons\HEXDD.wad"...
First HEXDD,wad is loaded as a required/startup component for the hexen-dk game mode (as IWAD data / non-custom). It is then tried again
because Snowberry specifies to load it using -file (as PWAD data / custom) suggesting that the lumps it contains are being appended to the
Lumplndex and thus overriding the previously loaded lumps. (Needs verifying.)

#3 - 2015-05-14 01:44 - danij

My take is this is simply obsolete logic in Snowberry - both HEXEN.WAD and HEXDD,WAD should be specified with -iwad so that -file can be used as
defined, allowing an IWAD to be passed and interpreted as a PWAD regardless of its identifier. (See relevant discussion here: #2047)

#4 - 2015-05-14 02:24 - danij

- Tags set to Hexen, Snowberry

- Assignee changed from danij to Deng Team

#5 - 2015-05-15 07:34 - danij

Build1595 - Snowberry is still using -file for HEXDD.wad for me.

Options.rsp:

-basedir "C:\Program Files (x86)\Doomsday"

-file "C:\Users\DaniJ\Documents\Doomsday Frontend\addons\HEXDD.wad"
—-sfxchan 16

—notexcomp

—game hexen-dk
—iwad "C:\Users\DaniJ\Documents\DOOM\IWADS\HEXEN.wad"

#6 - 2015-05-15 08:37 - skyjake
I'll do some Python debugging...

#7 - 2015-05-15 08:37 - skyjake
- % Done changed from 0 to 20

#8 - 2015-05-15 09:02 - skyjake

| tried it with Fedora, and it did work correctly: "-iwad" was used for both WADs, and hexdd.wad wasn't loaded twice at runtime.

#9 - 2015-05-15 10:25 - danij

On Windows the Python sources are compiled to bytecode .pyc files | believe, perhaps the executable was built from old versions?

#10 - 2015-05-15 10:42 - skyjake

Could you check if your copy of hexdd.wad actually identifies itself as an IWAD? | just tried 1595 on Windows and it did also work there correctly for
me.

bytecode .pyc

| think py2exe bytecompiles all the Python modules when it packages the executable, so this shouldn't be a problem.

#11 - 2015-05-15 10:53 - danij

Note that regardless of whether hexdd.wad is marked as an IWAD it should be treated by Snowberry as a required/startup game data file and
therefore specified with -iwad.

I'l check my copy...

#12 - 2015-05-15 11:12 - danij
My copy of hexdd.wad is indeed a PWAD

#13 - 2015-05-15 11:48 - skyjake

That's interesting. | wonder if yours is from a different version?
Well, this means Snowberry just has to treat the "hexdd-wad" addon as a special case and not rely on the identifier. I'll make the changes.

regardless of whether hexdd.wad is marked as an IWAD it should be treated by Snowberry as a required/startup game data file

Unfortunately, Snowberry lacks the concept of multiple startup data files, so this can't be solved without a kludge.
https://tracker.dengine.net/issues/2047

#14 - 2015-05-15 12:05 - danij

skyjake wrote:

That's interesting. | wonder if yours is from a different version?

Could be. Mine has been patched to 1.1

#15 - 2015-05-15 12:57 - vermil

My versions of DK 1.0 and 1.1 (from patching my 1.0 Iwad) are both marked as Iwads.

#16 - 2015-05-15 13:54 - skyjake
- Status changed from In Progress to Resolved

- % Done changed from 20 to 100

#17 - 2015-05-15 14:26 - skyjake

- Tags changed from Hexen, Snowberry to Hexen, Snowberry, Deathkings

#18 - 2015-05-18 22:23 - danij

- Status changed from Resolved to Closed
